package jp.co.sds_corp.tool.check;

import java.applet.Applet;

// import netscape.javascript.JSObject;

public class BrowserChecker extends Checker
{
	Applet applet;
	Browser browser;
	String appName;
	String userAgent;

	protected BrowserChecker(Applet applet) {
		this.applet = applet;
	}

	@Override
	public int getCheckCount() {
		return 1;
	}

	@Override
	public boolean check() {
		fireProgressNotify(ProgressListener.Type.HOLD, "ブラウザの確認");
		clearError();
		boolean ret = true;
//		getNavigator();
		addInfo("navigator.appName=" + appName);
		addInfo("navigator.userAgent=" + userAgent);
		browser = Browser.parse(appName, userAgent);
		addInfo("browser=" + browser);
		if (browser.getName().equals("Microsoft Internet Explorer")) {
			if (!checkIEVersion(browser)) {
				ret = false;
			}
		} else {
			ret = false;
			String msg = Message.formatMessage("90101", browser.getName());
			addError(msg);
		}
		fireProgressNotify(ProgressListener.Type.FORWARD, "ブラウザの確認");
		return ret;
	}

	public Browser getBrowser() {
		return this.browser;
	}

/*
	void getNavigator() {
        JSObject win = null;
        try {
        	win = JSObject.getWindow(applet);
        	if (win != null) {
        		appName = (String )win.call("getAppName", null);
        		userAgent = (String )win.call("getUserAgent", null);
        	}
        } catch (Exception ex) {
        	addDescription("can't get browser info.");
        	addDescription(ex);
        }
	}
*/

	boolean checkIEVersion(Browser browser) {
		boolean ret = true;
		if (browser.getVersion() == null) {
			String msg = Message.formatMessage("90102");
			addError(msg);
			return false;
		}
		float ver = 0.0f;
		try {
			ver = Float.valueOf(browser.getVersion()).floatValue();
		} catch (Exception ex) {
		}
		addInfo("IE version=" + browser.getVersion());
		if (ver < 6.0) {
			String msg = Message.formatMessage("90103", browser.getVersion());
			addError(msg);
			ret = false;
		}
		return ret;
	}

}
